dojo.hostenv.packageLoaded({
depends: [["provide", "dojo.widget.ResizableTextarea"],
["require", "dojo.widget.*"],
["require", "dojo.widget.LayoutContainer"],
["require", "dojo.widget.ResizeHandle"]],
definePackage: function(dojo){/*
	Copyright (c) 2004-2006, The Dojo Foundation
	All Rights Reserved.

	Licensed under the Academic Free License version 2.1 or above OR the
	modified BSD license. For more information on Dojo licensing, see:

		http://dojotoolkit.org/community/licensing.shtml
*/

dojo.provide("dojo.widget.ResizableTextarea");
dojo.require("dojo.widget.*");
dojo.require("dojo.widget.LayoutContainer");
dojo.require("dojo.widget.ResizeHandle");

dojo.widget.defineWidget(
	"dojo.widget.ResizableTextarea",
	dojo.widget.HtmlWidget,
{
	// summary
	//	A resizable textarea.
	//	Takes all the parameters (name, value, etc.) that a vanilla textarea takes.
	// usage
	//	<textarea dojoType="ResizableTextArea">...</textarea>

	templateString:"<div>\n	<div style=\"border: 2px solid black; width: 90%; height: 200px;\"\n		dojoAttachPoint=\"rootLayoutNode\">\n		<div dojoAttachPoint=\"textAreaContainerNode\" \n			style=\"border: 0px; margin: 0px; overflow: hidden;\">\n		</div>\n		<div dojoAttachPoint=\"statusBarContainerNode\" class=\"statusBar\">\n			<div dojoAttachPoint=\"statusLabelNode\" \n				class=\"statusPanel\"\n				style=\"padding-right: 0px; z-index: 1;\">drag to resize</div>\n			<div dojoAttachPoint=\"resizeHandleNode\"></div>\n		</div>\n	</div>\n</div>\n",
	templateCssString:"div.statusBar {\n	background-color: ThreeDFace;\n	height: 28px;\n	padding: 1px;\n	overflow: hidden;\n	font-size: 12px;\n}\n\ndiv.statusPanel {\n	background-color: ThreeDFace;\n	border: 1px solid;\n	border-color: ThreeDShadow ThreeDHighlight ThreeDHighlight ThreeDShadow;\n	margin: 1px;\n	padding: 2px 6px;\n}\n",templateCssPath: dojo.uri.dojoUri("src/widget/templates/ResizableTextarea.css"),

	fillInTemplate: function(args, frag){
		this.textAreaNode = this.getFragNodeRef(frag).cloneNode(true);

		// FIXME: Safari apparently needs this!
		dojo.body().appendChild(this.domNode);

		this.rootLayout = dojo.widget.createWidget(
			"LayoutContainer",
			{
				minHeight: 50,
				minWidth: 100
			},
			this.rootLayoutNode
		);

		// TODO: all this code should be replaced with a template
		// (especially now that templates can contain subwidgets)
		this.textAreaContainer = dojo.widget.createWidget(
			"LayoutContainer",
			{ layoutAlign: "client" },
			this.textAreaContainerNode
		);
		this.rootLayout.addChild(this.textAreaContainer);

		this.textAreaContainer.domNode.appendChild(this.textAreaNode);
		with(this.textAreaNode.style){
			width="100%";
			height="100%";
		}

		this.statusBar = dojo.widget.createWidget(
			"LayoutContainer",
			{ 
				layoutAlign: "bottom", 
				minHeight: 28
			},
			this.statusBarContainerNode
		);
		this.rootLayout.addChild(this.statusBar);

		this.statusLabel = dojo.widget.createWidget(
			"LayoutContainer",
			{ 
				layoutAlign: "client", 
				minWidth: 50
			},
			this.statusLabelNode
		);
		this.statusBar.addChild(this.statusLabel);

		this.resizeHandle = dojo.widget.createWidget(
			"ResizeHandle", 
			{ targetElmId: this.rootLayout.widgetId },
			this.resizeHandleNode
		);
		this.statusBar.addChild(this.resizeHandle);
	}
});

}});